/*
 * ----------------------------------------------------
 * 		public class AttendDao extends AbstractDao
 * ----------------------------------------------------
 * 
 * public AttendDao() //
 * public Vector getAllAttend() //⼮  
 * public Vector getIdAttend(String id) // ̵ ˻ؼ 
 *  //⼮ ߰ϱ
 * public boolean addAttend(String id, String attend, String late, String early, String finish, String adate)
 *   //⼮ 
 * public boolean updateAttend(String id, String attend, String late, String early, String finish, String adate, String bdate)
 * public AttendDto getAttend(String id, String aDate) //̵ ¥ ˻ؼ 1 
 * public boolean checkAttend(String id, boolean chk, String aDate) //  ٱ 
 * public boolean checkFinish(String id, boolean chk, String aDate) //   
 * public boolean isAttend(StudentDto dto, Calendar cal) //  ⼮ߴ
 * public boolean isGohome(StudentDto dto, Calendar cal) // ߴ
 * 
 * ⼮ attend  DAO
 * 
 */

package com.project.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Calendar;
import java.util.Vector;

import com.project.dto.StudentDto;
import com.project.dto.AttendDto;
import com.project.util.StudentMethod;
import com.project.util.StudentUtil;

public class AttendDao extends AbstractDao {

	public AttendDao() { // θȣ
		super();
	}
	
	public Vector getAllAttend() throws SQLException { // 
		Vector v = new Vector(2, 2);
		Connection conn = null;
		PreparedStatement psmt = null;
		ResultSet rs = null;
		
		try {
			conn = this.getConnection();
			// 3/6
			psmt = conn.prepareStatement(StudentUtil.GETALLATTEND);					
			// 4/6
			rs = psmt.executeQuery();
			
			while (rs.next()) { //rs   .
				int i = 2;
				String id = rs.getString(i++);
				String attend = StudentMethod.toStrNull(rs.getString(i++));
				String late = StudentMethod.toStrNull(rs.getString(i++));
				String early = StudentMethod.toStrNull(rs.getString(i++));
				String finish = StudentMethod.toStrNull(rs.getString(i++));
				String adate = StudentMethod.toStrNull(rs.getString(i++));

				v.add(new AttendDto(id, attend, late, early, finish, adate)); //dto Ϳ ִ´.
			} //while
		} catch (SQLException e) {
			System.out.println(" : getAllAttend" + e);
			throw new SQLException("getAllAttend"+e);
		} finally {
			this.close(conn, psmt, rs);
		} //try-catch
		return v;
	} //getAllAttend

	public Vector getIdAttend(String id) throws SQLException { //̵ 
		Vector v = new Vector(2, 2);
		Connection conn = null;
		PreparedStatement psmt = null;
		ResultSet rs = null;
		
		try {
			conn = this.getConnection();
			// 3/6
			psmt = conn.prepareStatement(StudentUtil.GETIDATTEND);					
			psmt.setString(1, id);
			// 4/6
			rs = psmt.executeQuery();
			while (rs.next()) {
				int i = 2;
				String ids = rs.getString(i++);
				String attend = StudentMethod.toStrNull(rs.getString(i++));
				String late = StudentMethod.toStrNull(rs.getString(i++));
				String early = StudentMethod.toStrNull(rs.getString(i++));
				String finish = StudentMethod.toStrNull(rs.getString(i++));
				String adate = StudentMethod.toStrNull(rs.getString(i++));
				
				//⼮ հ  ؼ  ų 0̸ 0 ׷   1 ó
				v.add(new AttendDto(ids, (attend.equals("")||attend.equals("0"))?0+"":1+"", (late.equals("")||late.equals("0"))?0+"":1+"", (early.equals("")||early.equals("0"))?0+"":1+"", (finish.equals("")||early.equals("0"))?0+"":1+"", adate)); 
			} //while
		} catch (SQLException e) {
			System.out.println(" : getIdAttend" + e);
			throw new SQLException("getIdAttend"+e);
		} finally {
			this.close(conn, psmt, rs);
		} //try-catch
		return v;
	} //getIdAttend
				
	//⼮ ߰ϱ
	public boolean addAttend(String id, String attend, String late, String early, String finish, String adate) throws SQLException {
		boolean ins = false;
		
		Connection conn = null;
		PreparedStatement psmt = null;
		
		try {
			conn = this.getConnection();
			// 3/6
			psmt = conn.prepareStatement(StudentUtil.ADDATTEND);
			psmt.setString(1, id.trim());
			psmt.setString(2, attend.trim());
			psmt.setString(3, late.trim());
			psmt.setString(4, early.trim());
			psmt.setString(5, finish.trim());
			psmt.setString(6, adate.trim());
			// 4/6
			int count = 0;
			count = psmt.executeUpdate();
			if (count > 0) {
				ins = true;
			}
		} catch (SQLException e) {
			System.out.println(" : addAttend" + e);
			throw new SQLException("addAttend"+e);
		} finally {
			this.close(conn, psmt, null);
		} //try-catch
		return ins;
	} //addAttend
	
	//⼮
	public boolean updateAttend(String id, String attend, String late, String early, String finish, String adate, String bdate) throws SQLException {
		boolean ins = false;
		AttendDto dto = new AttendDto();	
		Connection conn = null;
		PreparedStatement psmt = null;
		
		// Է¹   ʱȭ ʵ  ޾ƿͼ
		// Է¹   ٽ   ־ش.
		dto = this.getAttend(id, adate); 
		if (attend.equals(null) || attend.equals("")) {
			attend = dto.getAttend();
		}
		if (late.equals(null) || late.equals("")) {
			late = dto.getLate();
		}	
		if (early.equals(null) || early.equals("")) {
			early = dto.getEarly();
		}	
		if (finish.equals(null) || finish.equals("")) {
			finish = dto.getFinish();
		}	
		if (bdate.equals(null) || bdate.equals("")) {
			bdate = dto.getAdate();
		}	
		
		try {
			conn = this.getConnection();
			// 3/6 
			
			psmt = conn.prepareStatement(StudentUtil.UPDATEATTEND);
			psmt.setString(1, attend);
			psmt.setString(2, late);
			psmt.setString(3, early);
			psmt.setString(4, finish);
			psmt.setString(5, bdate);
			psmt.setString(6, id);
			psmt.setString(7, adate);
			// 4/6
			int count = 0;
			count = psmt.executeUpdate();
			if (count > 0) {
				ins = true;
			}
		} catch (SQLException e) {
			System.out.println(" : updateAttend" + e);
			throw new SQLException("updateAttend"+e);
		} finally {
			this.close(conn, psmt, null);
		} //try-catch finally
		return ins;
	}//updateAttend
	
	public AttendDto getAttend(String id, String aDate) throws SQLException {
		AttendDto dto = new AttendDto();
		Connection conn = null;
		PreparedStatement psmt = null;
		ResultSet rs = null;
		
		try {
			conn = this.getConnection();
			//System.out.println("2/6   : getIdAttend");
			// 3/6
			psmt = conn.prepareStatement(StudentUtil.GETATTEND);					
			psmt.setString(1, id);
			psmt.setString(2, aDate);
			//System.out.println("3/6  غ  : getIdAttend");
			// 4/6
			rs = psmt.executeQuery();
			//System.out.println("4/6   : getIdAttend");
			while (rs.next()) {
				int i = 2;
				String ids = rs.getString(i++);
				String attend = StudentMethod.toStrNull(rs.getString(i++));
				String late = StudentMethod.toStrNull(rs.getString(i++));
				String early = StudentMethod.toStrNull(rs.getString(i++));
				String finish = StudentMethod.toStrNull(rs.getString(i++));
				String bdate = StudentMethod.toStrNull(rs.getString(i++));
				
				dto.setId(ids.trim()); //   nullƴѰ͸ set
				if (attend != null) {
					dto.setAttend(attend.trim());
				}
				if (late != null) {
					dto.setLate(late.trim());
				}
				if (early != null) {
					dto.setEarly(early.trim());
				}
				if (finish != null) {
					dto.setFinish(finish.trim());
				}
				dto.setAdate(bdate.trim()); 
			}
			//System.out.println("5/6  : getIdAttend");
		} catch (SQLException e) {
			System.out.println(" : getIdAttend" + e);
			throw new SQLException("getIdAttend"+e);
		} finally {
			this.close(conn, psmt, rs);
		} //try-catch
		return dto;
	} //getAttend
	
	public boolean checkAttend(String id, boolean chk, String aDate) throws SQLException {
		boolean ins = false;
		Connection conn = null;
		PreparedStatement psmt = null;
				
		try {
			conn = this.getConnection();
			// 3/6
			psmt = conn.prepareStatement(StudentUtil.CHECKATTEND);					
			psmt.setString(1, id);
			psmt.setString(2, "1");
			if (chk == true) { //chk ̸ 1 ƴϸ ""
				psmt.setString(3, "1");
			} else {
				psmt.setString(3, "");
			}
			psmt.setString(4, "");
			psmt.setString(5, "");
			psmt.setString(6, aDate);
			
			int count = 0;
			count = psmt.executeUpdate();
			if (count > 0) {
				ins = true;
			}
			
		} catch (SQLException e) {
			System.out.println(" : checkAttend" + e);
			throw new SQLException("checkAttend"+e);
		} finally {
			this.close(conn, psmt, null);
		} //try-catch
		return ins;
	}	//checkAttend
	
	public boolean checkFinish(String id, boolean chk, String aDate) throws SQLException {
		boolean ins = false;
		Connection conn = null;
		PreparedStatement psmt = null;
		
		try {
				conn = this.getConnection();
			// 3/6
			psmt = conn.prepareStatement(StudentUtil.CHECKFINISH);					
			psmt.setString(1, id);
			psmt.setString(2, "");
			psmt.setString(3, "");
			if (chk == true) { // 1, ƴϸ ""
				psmt.setString(4, "1");
			} else {
				psmt.setString(4, "");
			}
			psmt.setString(5, "1");
			psmt.setString(6, aDate);
			
			int count = 0;
			count = psmt.executeUpdate();
			if (count > 0) {
				ins = true;
			}
			
		} catch (SQLException e) {
			System.out.println(" : checkFinish" + e);
			throw new SQLException("checkFinish"+e);
		} finally {
			this.close(conn, psmt, null);
		}
		return ins;
	} //checkFinish
		
     // ⼮ߴ Ȯϱ  ޼. ⼮  ⼮ ϵ 
	public boolean isAttend(StudentDto dto, Calendar cal) {
		Vector v = new Vector(2,2);
		AttendDto atDto = new AttendDto();
		boolean isAtd = false;
		
		Connection conn = null;
		PreparedStatement psmt = null;
		ResultSet rs = null;
		
		try {
			conn = this.getConnection(); // 2/6
					
			psmt = conn.prepareStatement(StudentUtil.ISATTEND); // 3/6
			psmt.setString(1, dto.getId().trim());
			rs = psmt.executeQuery(); // 4/6
						
			while(rs.next()) { // 5/6
				String date = rs.getString(7); //¥  ʿϱ ...
				v.add(new AttendDto(null, null, null, null, null, date)); 
			}
			
		} catch (SQLException e) {	
			System.out.println(" -- getStudent" + e);
		} finally {
			this.close(conn, psmt, rs);
		}
		
		for (int i=0; i<v.size(); i++) {
			atDto = (AttendDto)v.get(i);
			String str = atDto.getAdate(); 
			int idx = str.indexOf(' '); //¥ "/ :"̹Ƿ  ġ ãƿ´.
			//ó  ߶ͼ  /ϰ 
			if(str.substring(0, idx).equals( (cal.get(Calendar.MONTH)+1) + "/" + cal.get(Calendar.DATE))) { // ¥ ִ Ȯ
				isAtd = true;
			}
		}
		return isAtd;
	} //isAttend
	

//	   ⼮ߴ Ȯϱ  ޼.
	public boolean isGohome(StudentDto dto, Calendar cal) {
	   Vector v = new Vector(2,2);
	   AttendDto atDto = new AttendDto();
	   boolean isAtd = false;
	   
	   Connection conn = null;
	   PreparedStatement psmt = null;
	   ResultSet rs = null;
	   
	   try {
	    conn = this.getConnection(); // 2/6
	      
	    psmt = conn.prepareStatement(StudentUtil.ISGOHOME); // 3/6
	    psmt.setString(1, dto.getId().trim());
	    psmt.setString(2, "1");
	    rs = psmt.executeQuery(); // 4/6
	       
	    while(rs.next()) { // 5/6
	     String date = rs.getString(7); //¥ ʿϹǷ
	     v.add(new AttendDto(null, null, null, null, null, date)); 
	    }
	    
	   } catch (SQLException e) { 
	    System.out.println(" -- getStudent" + e);
	   } finally {
	    this.close(conn, psmt, rs);
	   }
	   
	   for (int i=0; i<v.size(); i++) {
	    atDto = (AttendDto)v.get(i);
	    String str = atDto.getAdate(); 
	    int idx = str.indexOf(' '); // ߶󳻱 ؼ  ãƿͼ ߶󳻼 ò 
	    if(str.substring(0, idx).equals( (cal.get(Calendar.MONTH)+1) + "/" + cal.get(Calendar.DATE))) { // ¥ ִ Ȯ
	     isAtd = true;
	    }
	   }
	   return isAtd;
	  } //isGohome
}
