/*
 * ----------------------------------------------------
 * 		public class GradeDao extends AbstractDao
 * ----------------------------------------------------
 * 
 * public AttendDao() //
 * public Vector getAllAttend() //⼮  
 * public Vector getIdAttend(String id) // ̵ ˻ؼ 
 *  //⼮ ߰ϱ
 * public boolean addAttend(String id, String attend, String late, String early, String finish, String adate)
 *   //⼮ 
 * public boolean updateAttend(String id, String attend, String late, String early, String finish, String adate, String bdate)
 * public AttendDto getAttend(String id, String aDate) //̵ ¥ ˻ؼ 1 
 * public boolean checkAttend(String id, boolean chk, String aDate) //  ٱ 
 * public boolean checkFinish(String id, boolean chk, String aDate) //   
 * public boolean isAttend(StudentDto dto, Calendar cal) //  ⼮ߴ
 * public boolean isGohome(StudentDto dto, Calendar cal) // ߴ
 * 
 *  grade  DAO
 * 
 */

package com.project.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import com.project.util.StudentMethod;
import com.project.util.StudentUtil;
import com.project.dto.GradeDto;



public class GradeDao extends AbstractDao {

	public GradeDao() {
		super();//
	}

	public Vector getAllGrade() throws SQLException{
		Vector v=new Vector(2,2);
		Connection conn=null;
		PreparedStatement passwordmt=null;
		ResultSet rs=null;
		try{
			
			conn=this.getConnection();
			//System.out.println("2/6 ");

			passwordmt=conn.prepareStatement(StudentUtil.GETALLGRADE);
			
			//System.out.println("3/6 ");

			rs=passwordmt.executeQuery();
			//System.out.println("4/6 ");
			
			while(rs.next()){
				int i=2;
				String id=StudentMethod.toStrNull(rs.getString(i++));
				String grade=StudentMethod.toStrNull(rs.getString(i++));
				String subject=StudentMethod.toStrNull(rs.getString(i++));

				v.add(new GradeDto(id, grade, subject));
			}
			//System.out.println("5/6 ");
		
		} catch(SQLException e){
			//System.out.println("5/6 ");
			throw new SQLException("getAllGrade "+e);
		}finally{
			this.close(conn,passwordmt,rs);
		}
		return v;
		
	}
	
	public Vector getIdGrade(String ids) throws SQLException{
		Vector v = new Vector(2, 2);
		
		Connection conn=null;
		PreparedStatement passwordmt=null;
		ResultSet rs=null;
		try{
			conn=this.getConnection();
			//System.out.println("2/6 ");
			// 3/6
			passwordmt=conn.prepareStatement(StudentUtil.GETIDGRADE);
			passwordmt.setString(1,ids.trim());
			//System.out.println("3/6 ");
			// 4/6
			rs=passwordmt.executeQuery();
			//System.out.println("4/6 ");
			
			while(rs.next()){
				int i=2;
				String id=StudentMethod.toStrNull(rs.getString(i++));
				String grade=StudentMethod.toStrNull(rs.getString(i++));
				String subject=StudentMethod.toStrNull(rs.getString(i++));

				v.add(new GradeDto(id, grade, subject));
			}
			//System.out.println("5/6 ");
		
		} catch(SQLException e){
			//System.out.println("5/6 ");
			throw new SQLException("getIdGrade "+e);
		}finally{
			this.close(conn,passwordmt,rs);
		}
		return v;	
	}
	
	public Vector getSubjectGrade(String subject) throws SQLException{
		Vector v = new Vector(2, 2);
		
		Connection conn=null;
		PreparedStatement passwordmt=null;
		ResultSet rs=null;
		try{
			conn=this.getConnection();
			//System.out.println("2/6 ");
			// 3/6
			passwordmt=conn.prepareStatement(StudentUtil.GETSUBJECTGRADE);
			passwordmt.setString(1,subject.trim());
			//System.out.println("3/6 ");
			// 4/6
			rs=passwordmt.executeQuery();
			//System.out.println("4/6 ");
			
			while(rs.next()){
				int i=2;
				String id=StudentMethod.toStrNull(rs.getString(i++));
				String grade=StudentMethod.toStrNull(rs.getString(i++));
				String subjects=StudentMethod.toStrNull(rs.getString(i++));

				v.add(new GradeDto(id, grade, subjects));
			}
			//System.out.println("5/6 ");
		
		} catch(SQLException e){
			System.out.println("5/6 ");
			throw new SQLException("getIdGrade "+e);
		}finally{
			this.close(conn,passwordmt,rs);
		}
		return v;	
	}
	
	public boolean AddGrade(String id, String grade, String subject) throws SQLException{
		boolean ins=false;
		Connection conn=null;
		PreparedStatement passwordmt=null;
		int count=0;	
		
		try {

			conn=this.getConnection();

			passwordmt=conn.prepareStatement(StudentUtil.ADDGRADE);
			passwordmt.setString(1,id.trim());
			passwordmt.setString(2,grade.trim());
			passwordmt.setString(3,subject.trim());
			
			count=passwordmt.executeUpdate();
			if(count>0){
				ins=true;
			}
		} catch (SQLException e) {
			System.out.println(" ߽ϴ, AddGrade"+e);
			throw new SQLException(" ߽ϴ, AddGrade"+e);
			
		}finally{
			close(conn,passwordmt,null);
		}
		return ins;
		
	}
	
	public boolean updateGrade(String id, String grade, String subject1, String subject2) throws SQLException{
		boolean upd=false;
		Connection conn=null;
		PreparedStatement passwordmt=null;
		int count=0;
		
		GradeDto dto = new GradeDto();
		dto = this.getGrade(id, subject2);
		if (grade.equals(null) || grade.equals("")) {
			grade = dto.getGrade();
		}
		if (subject1.equals(null) || subject1.equals("")) {
			subject1 = dto.getSubject();
		}
		
		try {

			conn=this.getConnection();

			passwordmt=conn.prepareStatement(StudentUtil.UPDATEGRADE);
			passwordmt.setString(1,grade.trim());
			passwordmt.setString(2,subject1.trim());
			passwordmt.setString(3,id.trim());
			passwordmt.setString(4,subject2.trim());

			count=passwordmt.executeUpdate();
			if(count<0){
				upd=true;
			}
		} catch (SQLException e) {
			System.out.println(" ߽ϴ, updateGrade"+e);
			throw new SQLException(" ߽ϴ, updateGrade"+e);
		}finally{
			close(conn,passwordmt,null);
		}
		return upd;
	}
	
	public GradeDto getGrade(String id, String subject) throws SQLException {
		GradeDto dto = new GradeDto();
		Connection conn = null;
		PreparedStatement psmt = null;
		ResultSet rs = null;
		
		try {
			conn = this.getConnection();
			//System.out.println("2/6   : getIdAttend");
			// 3/6
			psmt = conn.prepareStatement(StudentUtil.GETATTEND);					
			psmt.setString(1, id);
			psmt.setString(2, subject);
			//System.out.println("3/6  غ  : getIdAttend");
			// 4/6
			rs = psmt.executeQuery();
			//System.out.println("4/6   : getIdAttend");
			while (rs.next()) {
				int i = 2;
				String ids = rs.getString(i++);
				String grades = StudentMethod.toStrNull(rs.getString(i++));
				String subjects = StudentMethod.toStrNull(rs.getString(i++));
				
				dto.setId(ids.trim()); 
				if (grades != null) {
					dto.setGrade(grades.trim());
				}
				if (subjects != null) {
					dto.setSubject(subjects.trim());
				}
			}
			//System.out.println("5/6  : getIdAttend");
		} catch (SQLException e) {
			System.out.println(" : getIdAttend" + e);
			throw new SQLException("getIdAttend"+e);
		} finally {
			this.close(conn, psmt, rs);
		}
		return dto;
	}
	
	public boolean deleteGrade(String id, String subject) throws SQLException {
		boolean del=false;
		Connection conn=null;
		PreparedStatement passwordmt=null;
		int count=0;
		
		
		try {
			conn=this.getConnection();

			passwordmt=conn.prepareStatement(StudentUtil.DELETEGRADE);
			passwordmt.setString(1,id.trim());
			passwordmt.setString(2,subject.trim());

			count=passwordmt.executeUpdate();
			if(count<0){
				del=true;
			}
		} catch (SQLException e) {
			System.out.println(" ߽ϴ, deleteGrade"+e);
			throw new SQLException(" ߽ϴ, deleteGrade"+e);
			
		}finally{
			close(conn,passwordmt,null);
		}
		return del;
		
	}
	
	public boolean hasSubject(String subject) { 
		boolean hasl = false; //ϰ ֱ 
		
		Connection conn = null;
		PreparedStatement psmt = null;
		ResultSet rs = null;
		
		try {
			conn = this.getConnection();// 2/6
			
			psmt = conn.prepareStatement(StudentUtil.HASSUBJECT); //3/6
			psmt.setString(1, subject.trim() );
			
			rs = psmt.executeQuery(); // 4/6
			
			// 5/6
			if(rs.next()) {
				hasl = true;
			}
			
		} catch (SQLException e) {
			System.out.println("hasSubject ");
		} finally {
			close(conn, psmt, rs);
		}
		return hasl;
	} //hasId
}
